# WEB+DB PRESS Vol.133 現場のPythonサンプルコード

## 概要

2023年2月発売の[WEB+DB PRESS Vol.133](https://gihyo.jp/magazine/wdpress/archive/2023/vol133)連載「現場のPython【第17回】Django ORM道場 ……クエリの基本を押さえ，より良い型を身に付けよう 」のサンプルコードです。

## 動作確認したバージョン

* Python 3.10.7
* Django 4.1.6

## 環境構築

以下の手順でPythonの[venv](https://docs.python.org/ja/3.10/library/venv.html)で仮想環境を作成して、ライブラリをインストールします。

* macOS、Linuxの場合

```bash
$ python3.10 -m venv venv
$ . venv/bin/activate
(venv) $ pip install -r requirements.txt
```

* Windowsの場合

```console
> python -m venv venv
> Set-ExecutionPolicy RemoteSigned -Scope CurrentUser -Force
> venv/Scripts/Activate.ps1
(venv) > pip install -r requirements.txt
```

## ファイルの説明

以下は記事の中に出てきたコード、設定ファイル、辞書ファイルです。

* `proj/`: Djangoプロジェクトのルートディレクトリ
* `proj/proj/settings.py`: Djangoプロジェクト設定のLOGGING定義
* `proj/app/models.py`: Staff等のモデル定義
* `proj/app/views.py`: Staff一覧画面用view関数定義
* `proj/app/templatetags/status.py`: staff_status フィルタ関数定義
* `proj/app/templates/index.html`: Staff一覧画面用HTML
* `proj/try1.py`: 「意図しないタイミングでのSQL発行を避ける」節で作成した試行錯誤用の集約コード
* `proj/try2.py`: 「意図しないタイミングでのSQL発行を避ける」節で作成した試行錯誤用の集約コード
* `requirements.txt`: venv用にライブラリをまとめたファイル(環境構築で使用)

## Djangoプログラム実行方法

```bash
(venv) $ cd proj
(venv) $ python manage.py migrate
(venv) $ python manage.py runserver
-- 中略 --
Django version 4.1.6, using settings 'proj.settings'
Starting development server at http://127.0.0.1:8000/
Quit the server with CONTROL-C.
```

ブラウザで http://127.0.0.1:8000/staff/ にアクセスしてください。

## 試行錯誤用コード実行方法

```bash
(venv) $ python try1.py
(venv) $ python try2.py
```
