import os
import django
os.environ.setdefault("DJANGO_SETTINGS_MODULE", "proj.settings")
django.setup()

# ここから集約したコード
from app.models import Staff
from app.templatetags.status import staff_status, staff_status_dict

print("### 元のクエリ")
staffs = (
    Staff.objects.order_by("-last_login")
    .only("pk", "name"))
for staff in staffs:
    print({
        "pk": staff.pk, "name": staff.name,
        "status": staff_status(staff)})


# ----------------------------

print("### 改善版")
staffs = (
    Staff.objects
    .order_by("-last_login")
    .values("pk", "name", "last_login")
)
for staff in staffs:
    print({
        "pk": staff["pk"], "name": staff["name"],
        "status": staff_status_dict(staff)})
